﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace uchatPchr
{

	public partial class Form1 : Form
	{

		Queue<CheckResult> q = new Queue<CheckResult>(5000);
		int WNumber = 0;
		bool thread_end = false;
		public Form1()
		{
			InitializeComponent();
			sendBuffer = System.Text.Encoding.UTF8.GetBytes("Sorry_its_Test\r\n\r\n");

			//CheckResult cr = _checkPort(80, 5);
			button1.Click += Button1_Click;
			CheckForIllegalCrossThreadCalls = false;

			this.FormClosing += Form1_FormClosing;
			
			listBox1.Sorted = true;

			this.button2.Click += Button2_Click;
		}

		private void Button2_Click(object sender, EventArgs e)
		{
			MessageBox.Show("이 프로그램은 http://portquiz.net/ 을 이용해서 제작되었습니다.");
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			++WNumber;
		}

		private void Button1_Click(object sender, EventArgs e)
		{
			++WNumber;
			new System.Threading.Thread(() => _list_update((int)(pTo.Value - pFrom.Value) + 1, WNumber)).Start();
			int timeout = (int)(Timeout.Value * 1000);
			int threadSplit = (int)numericUpDown1.Value;

			for (int i = 0; i < (pTo.Value - pFrom.Value) / threadSplit;)
			{
				int from = (int)pFrom.Value  - 1 + (threadSplit * i);
				int to = (int)(pFrom.Value + (threadSplit * (i + 1)) > pTo.Value ? pTo.Value : pFrom.Value + (threadSplit * (i + 1))) + 1;
				++i;

				new System.Threading.Thread(() => ThreadWork(from, to, timeout, WNumber)).Start();
				System.Threading.Thread.Sleep(10);
			}

			thread_end = true;
		}

		private void _list_update(int length, int WNumber) {
			while (! thread_end)
				System.Threading.Thread.Sleep(10);
			
			for (int i = 0; i < length; i++)
			{
				while(q.Count == 0) {
					System.Threading.Thread.Sleep(10);
				}

				CheckResult cr = q.Dequeue();
                if (cr.port == 0)
                {
                    continue;
                }

				if(cr.success) {
					richTextBox2.Text += cr.port + " (" + cr.res + "ms)\r\n";
					listBox1.Items.Add(cr.port);

				}else {
					if(cr.error != "")
						richTextBox3.Text += cr.port + ": "  + cr.error + "\r\n\r\n";

					richTextBox1.Text += cr.port + " (" + _error(cr.res) + ")\r\n";
				}

                this.Text = "ESukmean's Program - Mozilla Firefox : " + i.ToString();
			}
		}


		private string _error(long n) 
		{
			switch ((ErrorStep)n)
			{
				case ErrorStep.Unknown:
					return "알수 없음 - connect 전";
				case ErrorStep.CreateSocket:
					return "소켓 생성시";
				case ErrorStep.Connect:
					return "연결중";
				case ErrorStep.Send:
					return "메세지 전송시";
				case ErrorStep.Read:
					return "읽으려고 할때";
				case ErrorStep.okNoClose:
					return "송/수신은 정상이나 소켓을 안닫아줌";
				case ErrorStep.DataWrong:
					return "수신된 데이터 오류";
				default:
					return "오류코드 이상";
			}
		}

		//==========================================================



		//==========================================================

		private void ThreadWork(int start, int end, int timeout, int WNumber) 
		{ 	
			while (++start < end && WNumber == this.WNumber) {
				CheckResult CR = _checkPort((ushort)start, timeout);
				q.Enqueue(CR);

				if (CR.success) {
					System.Threading.Thread.Sleep(250);
				}

				System.Threading.Thread.Sleep(50);
			}
		}

		byte[] sendBuffer = { };

		struct CheckResult {
			public bool success;
			public ushort port;
			public long res;

			public string error;
		}

		enum ErrorStep {
			Unknown = -1,
			CreateSocket = -2,
			Connect = -3,
			Send = -4,
			Read = -5,
			okNoClose = -6,
			DataWrong = -7,
			ConnectedButClosed = -8

		}
		private CheckResult _checkPort(ushort p, int timeout) {
			CheckResult CR = new CheckResult();

            CR.error = "";
			CR.port = p;
			CR.success = false;
			CR.res = (int)ErrorStep.Unknown;

			ErrorStep step = ErrorStep.CreateSocket;
			
			System.Diagnostics.Stopwatch sw = new System.Diagnostics.Stopwatch();

			sw.Start();
			System.Net.Sockets.TcpClient TC = new System.Net.Sockets.TcpClient();
			TC.ReceiveTimeout = timeout;
			TC.SendTimeout = timeout;

			try {
				step = ErrorStep.Connect;

				IAsyncResult connectRes = TC.BeginConnect("portquiz.net", p, null, null);
				if (connectRes.AsyncWaitHandle.WaitOne(timeout, true) == false)
				{
					throw new TimeoutException();
				}

				if(TC.Connected == false) 
				{
					step = ErrorStep.ConnectedButClosed;
					throw new Exception();
				}

				System.Net.Sockets.NetworkStream NS = TC.GetStream();

				step = ErrorStep.Send;
				NS.Write(sendBuffer, 0, sendBuffer.Length);

				byte[] readBuffer = new byte[256];
				step = ErrorStep.Read;

				int r = -1;
				while(r != 0) {
					r = NS.Read(readBuffer, 0, 256);

					if(r > 0) {
						if(System.Text.Encoding.UTF8.GetString(readBuffer).IndexOf("<!DOCTYPE HTML PUBLIC ") == 0) {
							CR.success = true;
							CR.res = sw.ElapsedMilliseconds;

							step = ErrorStep.okNoClose;	
						}else {
							step = ErrorStep.DataWrong;
						}
					}
				}

				sw.Stop();

			}catch (Exception e) {
				CR.error = e.ToString();
				
				CR.success = false;
				CR.res = (long)step;
			}finally {
				TC.Close();
			}

			return CR;
		}
	}
}
